(defun meow-setup ()
  (setq meow-cheatsheet-layout meow-cheatsheet-layout-qwerty)
  (setq meow-keypad-start-keys '((?c . ?c) (?x . ?x)))
  (meow-motion-overwrite-define-key
   '("en" . (lambda () (interactive) (delete-other-windows)(find-file "/mnt/s/deft/scratch.txt"))) ;; home
       '("ep" . play-music-from-dired)
       '("er" . random-album)
    '("s" . swiper)
    '("ee" . execute-extended-command)
       '("o" . counsel-buffer-or-recentf)
    '("<escape>" . ignore))
  (meow-leader-define-key
;; Use SPC (0-9) for digit arguments.
   '("1" . meow-digit-argument)
   '("2" . meow-digit-argument)
   '("3" . meow-digit-argument)
   '("4" . meow-digit-argument)
   '("5" . meow-digit-argument)
   '("6" . meow-digit-argument)
   '("7" . meow-digit-argument)
   '("8" . meow-digit-argument)
   '("9" . meow-digit-argument)
   '("0" . meow-digit-argument)
   '("-" . meow-keypad-describe-key)
   '("?" . meow-cheatsheet))
  (meow-normal-define-key
   '("0" . meow-expand-0)
   '("9" . meow-expand-9)
   '("8" . meow-expand-8)
   '("7" . meow-expand-7)
   '("6" . meow-expand-6)
   '("5" . meow-expand-5)
   '("4" . meow-expand-4)
   '("3" . meow-expand-3)
   '("2" . meow-expand-2)
   '("1" . meow-expand-1)
   '("-" . negative-argument)
   '(";" . meow-reverse)
   '("," . meow-inner-of-thing)
   '("." . meow-bounds-of-thing)
   '("/" . meow-search)
   '("A" . meow-open-below)
   '("B" . meow-back-symbol)
   '("C" . meow-change)
   '("E" . meow-goto-line)
   '("H" . meow-left-expand)
   '("I" . meow-open-above)
   '("M" . meow-mark-symbol)
   '("N" . meow-next-expand)
   '("O" . meow-open-above)
   '("P" . meow-prev-expand)
   '("Q" . meow-goto-line)
   '("R" . meow-swap-grab)
   '("T" . meow-till)
   '("U" . meow-undo-in-selection)
   '("W" . meow-next-symbol)
   '("X" . meow-sync-grab)
   '("a" . meow-append)
   '("c" . meow-save)
   '("g" . meow-beginning-of-thing)
   '("d" . meow-delete)
   '("f" . meow-find)
   '("b" . meow-end-of-thing)
   '("h" . meow-cancel-selection)
   '("i" . meow-insert)
   '("k" . meow-line)
   '("l" . save-buffer)
   '("m" . meow-mark-word)
   '("n" . meow-next-word)
   '("o" . counsel-buffer-or-recentf)
   '("p" . meow-grab)
   '("q" . meow-replace)
   '("r" . save-buffer)
   '("s" . swiper)
   '("t" . meow-back-word)
   '("u" . meow-undo)
   '("v" . meow-yank)
   '("w" . meow-mark-word)
   '("x" . meow-kill)
   '("y" . meow-pop-selection)
   '("z" . meow-visit)
   ;;;;'("k" . meow-kill)
 ;;;;  '("p" . meow-prev)
  ;;;; '("." . repeat)

    ; prefixes
    '(":w" . save-buffer)
    '(":x" . execute-extended-command)
    '("eab" . eval-buffer)
    '("ead" . insert-date) ;; paste date
    '("eag" . goto-random-line)
    '("eal" . duplicate-line)
    '("eam" . play-music-from-dired)
    '("ean" . new-bookmark)
    '("ear" . meow-query-replace)
    '("eat" . toggle-mode-line)
    '("eax" . dired-toggle-read-only) ;; directory edit
    '("eaz" . ledger-mode-clean-buffer)
    '("eb" . previous-buffer)
    ;;  c 
    '("ed" . play-music-from-dired) ;; available
    '("ee" . execute-extended-command)
    '("ef" . next-buffer)
    ;;  g 
    '("eh m" . mode-line-hide-mode)
    '("eh l" . view-lossage)
    '("eh k" . helpful-key)
    '("eh v" . helpful-variable)
    '("eh x" . helpful-command)
    '("ei c" . (lambda () (interactive) (insert "“")))
    '("ei l" . (lambda () (interactive) (insert "<li>")))
    '("ei r" . (lambda () (interactive) (insert "”")))
    '("ei v" . (lambda () (interactive) (insert "’")))
    '("ei w" . (lambda () (interactive) (insert "‘")))
    ;; j
    ;; k
    '("elm" . link-hint-open-multiple-links)
    '("ell" . link-hint-open-link)
    '("emc" . meow-comment)
    '("emt" . meow-tutor)
    '("en" . (lambda () (interactive) (delete-other-windows)(find-file "/mnt/s/deft/scratch.txt"))) ;; home
    '("eo" . counsel-buffer-or-recentf)
    '("ep" . play-music-from-dired)
    '("eq" . keyboard-menu)
    '("e/" . meow-search)
    '("er" . random-album)
    '("eta" . (lambda () (interactive) (delete-other-windows)(find-file "/mnt/s/deft/addresses.txt")))
    '("etb" . (lambda () (interactive) (delete-other-windows)(find-file "/mnt/s/deft/bookmarks.org")))
    '("etc" . (lambda () (interactive) (delete-other-windows)(find-file "/o/config/nixos/current/configuration.nix")))
    '("etd" . (lambda () (interactive) (delete-other-windows)(find-file "/mnt/s/deft/")))
    '("ete" . (lambda () (interactive) (delete-other-windows)(find-file "/o/orpeth")))
    '("eth" . (lambda () (interactive) (delete-other-windows)(find-file "/home/jason/")))
    '("eti" . (lambda () (interactive) (delete-other-windows)(find-file "/o/emacskit/init.el")))
    '("etm" . (lambda () (interactive) (delete-other-windows)(find-file "/music")))
    '("etn" . (lambda () (interactive) (delete-other-windows)(find-file "/mnt/s/deft/scratch.txt")))
    '("eto" . counsel-buffer-or-recentf)
    '("etp" . (lambda () (interactive) (delete-other-windows)(find-file "/mnt/s/deft/places.txt"))) 
    '("ett" . (lambda () (interactive) (delete-other-windows)(find-file "/mnt/s/deft/todo-bullet-list.txt")))
    '("etw" . (lambda () (interactive) (delete-other-windows)(find-file "/mnt/s/deft/dog walks.txt"))) 
    '("ety" . (lambda () (interactive) (delete-other-windows)(find-file "/t/incoming/")))
    '("eua" . elfeed-launch-and-back-home)
    '("euc" . elfeed-unjam)
    '("euh" . elfeed-update-and-back-home)
    '("eun" . elfeed-update-and-back-home)
    '("eup" . elfeed-launch-and-back-home)
    '("eut" . elfeed-launch-and-back-home)
    '("eur" . elfeed)
    '("eus" . elfeed-update)
    '("euu" . elfeed)
    '("ew" . other-window)
    ;;  x 
    '("ey" . delete-other-windows)
    '("ezi" . text-scale-increase)
    '("ezn" . zone)
    '("ezo" . text-scale-decrease)
    '("ezz" . (lambda () (interactive) (text-scale-set 0)))
    '("<escape>" . ignore)
   ))

;; yank means copy in vim and means paste in emacs

(add-to-list 'load-path (expand-file-name "~/.config/emacs/meow/"))
(require 'meow)
(meow-setup)
(setq meow-use-clipboard 1) ;; system clipboard
(meow-global-mode 1)

;;fix lockfile warning
;;;; can move this to fluff file
(setq-default create-lockfiles nil)

;;;; (load "/o/c/emacs/init/functions.el" t)

(setq browse-url-browser-function 'browse-url-generic)
(setq browse-url-generic-program "/run/current-system/sw/bin/qutebrowser")

(setq save-interprogram-paste-before-kill t)

(require 'recentf)
(setq recentf-max-saved-items 250)
(setq recentf-max-menu-items 0)
;; Make recentf (and its helm descendants) include directories shown in dired.
(defun recentd-track-opened-file ()
  (and (derived-mode-p 'dired-mode) default-directory
       (recentf-add-file default-directory))
  nil)
(add-hook 'dired-after-readin-hook 'recentd-track-opened-file)

;; server
(require 'server)
(or (server-running-p)
    (server-start))

"case-insensitive tab completion in the minibuffer (and elsewhere)"
(setq completion-ignore-case  t)
(setq read-file-name-completion-ignore-case t)
(setq read-buffer-completion-ignore-case t)

;;; MODES AND MODE HOOKS

(context-menu-mode)
(add-to-list 'auto-mode-alist '("\\household-money.txt\\'" . ledger-mode))
(add-to-list 'auto-mode-alist '("\\.tex\\'" . text-mode)) ; for speed!

(add-hook 'dired-mode-hook 'dired-hide-details-mode)

(auto-fill-mode -1)
(remove-hook 'text-mode-hook 'auto-detect-wrap)

(goto-address-mode t)
(follow-mode t)
(global-visual-line-mode nil) ;; This makes swiper very slow.  I think it's fine with helm.
;; (scroll-lock-mode t)
(display-time-mode t)
(save-place-mode t) ;; save cursor positions on exit
(setq auto-save-visited-interval 1)
(auto-save-visited-mode)

;; dired
(setq dired-dwim-target t) ;; Default target is in the next window.
;; allow dired to delete or copy dir
(setq dired-recursive-copies (quote always)) ; “always” means no asking
(setq dired-recursive-deletes (quote top)) ; “top” means ask once
(setq dired-listing-switches "-lh")  ;; human-readable sizes
(setq dired-auto-revert-buffer t)
(setq auto-revert-verbose nil)

;; ui - user interface - gui

;; Disable the pop-up buffer menu which wants to be shown on C-down-mouse-1 (which, if you have a trackpad, you probably trigger all the time by accident).
;; I'm not sure whether this works or not.
(defun mouse-buffer-menu (event) (ignore))

(desktop-save-mode 0)

;; Faces
(setq frame-inhibit-implied-resize t)
(set-face-attribute 'variable-pitch nil :height 110 :family "Tex Gyre Bonum")
;; (set-face-attribute 'variable-pitch nil :height 110 :family "Source Serif Variable Light")
(add-hook 'emacs-lisp-mode-hook (lambda () (variable-pitch-mode 1)))
(add-hook 'text-mode-hook (lambda () (variable-pitch-mode 1)))

;; Lose the startup screen, the scroll bar, the menu bar, and the tool bar.
(setq inhibit-startup-screen t)
(if (fboundp 'tool-bar-mode) (tool-bar-mode -1))
(menu-bar-mode -1)
(scroll-bar-mode -1)

;; mode line
(defvar-local mode-line-hide-mode nil)

(define-minor-mode mode-line-hide-mode
  "Minor mode to hide the mode-line in the current buffer.  © Bastien Guerry - CC by-sa 4.0  https://bzg.fr/en/emacs-hide-mode-line/"
  :init-value nil
  :global t
  :variable mode-line-hide-mode
  :group 'editing-basics
  (if mode-line-hide-mode
      (setq hide-mode-line mode-line-format
            mode-line-format nil)
    (setq mode-line-format hide-mode-line
          hide-mode-line nil))
  (force-mode-line-update)
  ;; Apparently force-mode-line-update is not always enough to
  ;; redisplay the mode-line
  (redraw-display)
  (when (and (called-interactively-p 'interactive)
             mode-line-hide-mode)
    (run-with-idle-timer
     0 nil 'message
     (concat "Hidden Mode Line Mode enabled.  "
             "Use M-x mode-line-hide-mode to make the mode-line appear."))))

;; If you want to hide the mode-line in every buffer by default
(add-hook 'after-change-major-mode-hook 'mode-line-hide-mode)

;; Margins!  YES!  I don't use a fringe for margins - I don't remember why but probably because emacs likes to put STUFF in the fringe, or maybe because the fringe is a different colour from the rest of the frame by default - but anyway what I have here works very well.
(fringe-mode 0)
;; (custom-set-faces '(fringe ((t (:background "white"))))) ;; only necessary for modes that turn the fringe back on again!
(setq-default left-margin-width 5 right-margin-width 5) 
(set-frame-parameter (selected-frame) 'internal-border-width 20)

;; SMOOTH SCROLLING
(setq mouse-wheel-scroll-amount '(1 ((shift) . 1))) ;; one line at a time
(setq mouse-wheel-progressive-speed nil) ;; don't accelerate scrolling
(setq scroll-step 1) ;; keyboard scroll one line at a time
(pixel-scroll-precision-mode 1)

(setq show-paren-context-when-offscreen 'overlay)

;; Silence the audible bell.
(setq ring-bell-function 'ignore)

;; cursor
 (blink-cursor-mode 0)

;; line numbers
(line-number-mode) ;; this should disable it - I need the space


;; yes/no prompts
(fset 'yes-or-no-p 'y-or-n-p)

;; exit without prompting even if there are live subprocesses
(setq confirm-kill-processes nil)

;; DRAG AND DROP
;; (setq mouse-drag-and-drop-region t)

;; swiper
(setq ivy-re-builders-alist
      '((t . ivy--regex-ignore-order)))

(setq initial-scratch-message "")

(custom-set-variables
 ;; custom-set-variables was added by Custom.
 ;; If you edit it by hand, you could mess it up, so be careful.
 ;; Your init file should contain only one such instance.
 ;; If there is more than one, they won't work right.
 '(make-backup-files nil)
 '(meow-char-thing-table
   '((114 . round)
     (115 . square)
     (99 . curly)
     (103 . string)
     (101 . symbol)
     (119 . window)
     (98 . buffer)
     (112 . paragraph)
     (110 . line)
     (118 . visual-line)
     (100 . defun)
     (46 . sentence)))
 '(meow-expand-hint-counts '((word . 0) (line . 0) (block . 0) (find . 0) (till . 0)))
 '(warning-suppress-log-types '((comp))))
